SystemOrganization addCategory: #GTD!
SystemOrganization addCategory: 'GTD-Commands'!
SystemOrganization addCategory: 'GTD-Model'!
SystemOrganization addCategory: 'GTD-Tests'!

Object subclass: #Agente
	instanceVariableNames: 'proyectos realizacionesDeProyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Agente commentStamp: 'SergioFedi 4/24/2015 18:49' prior: 0!
Soy una entidad que tiene agencia. Es decir, que quiere lograr algo en la realidad. Por lo tanto voya tener proyectos que voy a querer llevar a cabo.!

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/23/2015 11:00'!
addProyecto: aProyecto 
	self proyectos add: aProyecto.! !

!Agente methodsFor: 'initialization' stamp: 'FedericoFigueredo 4/23/2015 11:07'!
initialize

	self proyectos: OrderedCollection new.! !

!Agente methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:50'!
marcarComoHecha: anAccion 
	| proyecto | 
	
	proyecto := self proyectos detect: [ :each | each includesAccion: anAccion ].
	
	proyecto marcarComoHecha: anAccion.! !

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/27/2015 09:49'!
nextActions
	^ self proyectos collect: [ :aProyecto | aProyecto nextAction ].
	! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos
	^ proyectos! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos: anObject
	proyectos := anObject! !

Object subclass: #AgregarProyectoCmd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!AgregarProyectoCmd commentStamp: 'SergioFedi 4/25/2015 10:07' prior: 0!
Modelo el agregado de un Proyecto al sistema desde fuera del sistema.
!

Object subclass: #Proyecto
	instanceVariableNames: 'nombre condicionDeExito acciones accionesHechas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Proyecto commentStamp: 'FedericoFigueredo 4/23/2015 14:28' prior: 0!
Llamamos Proyecto a un estado de la realidad deseado para el cual se requieren la realización de más de una acción.!

!Proyecto class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:07'!
example
	| acciones unProyecto | 
	
	acciones := OrderedCollection new.
	unProyecto := self new.
	
	acciones
		add: 'Llamar al dentista para pedir un turno';
		add: 'Agregar el turno a mi calendario';
		add: 'Ir a la consulta';
		add: 'Cargar la tarjeta SUBE'.
	unProyecto
		nombre: 'Chequeo Dental';
		condicionDeExito: 'Saber el estado actual de mis dientes';
		acciones: acciones.
	
	^ unProyecto.! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones
	^ acciones! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones: anObject
	acciones := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/27/2015 10:20'!
accionesHechas
	^ accionesHechas! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/27/2015 10:20'!
accionesHechas: anObject
	accionesHechas := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito
	^ condicionDeExito! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito: anObject
	condicionDeExito := anObject! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:40'!
includesAccion: anAccion 
	^ self acciones includes: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:24'!
initialize
	acciones := OrderedCollection new.
	accionesHechas := OrderedCollection new.
	! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:24'!
isHecha: anAccion 
	^ self accionesHechas includes: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:51'!
marcarComoHecha: anAccion 
	self accionesHechas add: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:37'!
nextAction
	^ self acciones detect: [ :accion | (self isHecha: accion) not ].! !

!Proyecto methodsFor: 'public' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre: anObject
	nombre := anObject! !

TestCase subclass: #AgenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Tests'!

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:01'!
newAgenteDePrueba
	| agente unProyecto  |
	
	agente := Agente new.
	unProyecto := Proyecto example.
	agente addProyecto: unProyecto.
	
	^ agente.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:04'!
test_01_AltaDeUnProyecto
	| agente  |
	
	agente := Agente new.
	
	self assert: agente proyectos isEmpty.
	
	agente addProyecto: Proyecto example.
	
	self assert: agente proyectos notEmpty.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 13:56'!
test_02_CualesSonLasNextActions
	| agente actions expectedAction |

	agente := self newAgenteDePrueba.
	actions := agente nextActions.
	expectedAction := 'Llamar al dentista para pedir un turno'.
	
	self assert: actions anyOne = expectedAction.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/23/2015 14:07'!
test_03_MarcarUnaNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar accionSiguiente |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Llamar al dentista para pedir un turno'.
	accionSiguiente := 'Agregar el turno a mi calendario'.
	accionAMarcar := agente nextActions anyOne.
	
	self assert: accionAMarcar = descripcionDeLaAccionAMarcar.
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne = accionSiguiente.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 09:52'!
test_04_MarcarUnaNoNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar accionSiguiente proyecto |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Cargar la tarjeta SUBE'.
	accionSiguiente := 'Llamar al dentista para pedir un turno'.
	proyecto := agente proyectos first.
	accionAMarcar := proyecto acciones last.
	
	self assert: accionAMarcar = descripcionDeLaAccionAMarcar.
	self deny: (proyecto isHecha: accionAMarcar).
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne = accionSiguiente.
	self assert: (proyecto isHecha: accionAMarcar).
	! !

TestCase subclass: #ProyectoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Tests'!

!ProyectoTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:27'!
test_01_AgregarUnaAccionAUnProyecto
	
	self assert: false.! !
